pipeline {
	environment {
		DOCKERHUB_CREDENTIALS=credentials('dh_cred')
        imageNameBack='bileltriaa/spring-back'
	      imageVersionBack="${BUILD_NUMBER}"
        imageNameFront='bileltriaa/angular-front'
        imageVersionFront="${BUILD_NUMBER}"
        PROJECT_NAME='SpringAngular_5GI'
	}
  agent any
	stages {

    stage('SCM') {
			steps {
    			checkout scm
			}
  	}
    stage('Build Docker Back Image') {
      steps {
          sh 'docker build -t ${imageNameBack}:${imageVersionBack} -f back/Dockerfile ./back'
          echo 'Building Docker Back Image Successfuly'
      }
    }

    stage('Build Docker Front Image') {
      steps {
          sh 'docker build -t ${imageNameFront}:${imageVersionFront} -f front/Dockerfile ./front'
          echo 'Building Docker Front Image Successfuly'
      }
    }

    stage('Login to Dockerhub') {
      steps {
          sh 'echo $DOCKERHUB_CREDENTIALS_PSW | docker login -u $DOCKERHUB_CREDENTIALS_USR --password-stdin'
          echo 'Login to Dockerhub Successfuly'
      }
    }
    
    stage('Push Images to DockerHub') {
      steps {
          sh 'docker push ${imageNameBack}:${imageVersionBack}'
          echo 'Pushing Image ${imageNameBack}:${imageVersionBack} Successfuly'
          sh 'docker push ${imageNameFront}:${imageVersionFront}'
          echo 'Pushing Image ${imageNameFront}:${imageVersionFront} Successfuly'
      }
    }
  /*
    stage('Clean local env') {
      steps {
          sh 'docker logout $DOCKERHUB_CREDENTIALS_USR'
          sh 'docker image rm ${imageNameBack}:${imageVersionBack}'
          sh 'docker image rm ${imageNameFront}:${imageVersionFront}'
          echo 'Cleaning Done Successfuly'
      }
    }
  */
    stage('Deploy with docker compose') {
      steps {
          sh 'versionBack=${imageVersionBack} versionFront=${imageVersionFront} docker-compose -f docker-compose.yml up -d'
          echo 'Successfuly Deployed ${PROJECT_NAME} to docker compose'
      }
    }
  }
}